/*
	$Id: Group.java 247 2006-08-08 22:27:44Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   饹ޤϥ󥿥եǤ

   classǤޤinterfaceǤδ쥯饹Ǥ
*/
public abstract class Group {

    /** ѥå̾ */
    private String packageName;

    /** ̾ */
    private String name;

    /** ̾ */
    private String nameSpace;

    /** descǤ */
    private Description desc;

    /** 롼ץޥ͡ */
    private GroupManager gm;

    /** ҥΡɥե륿 */
    private ChildrenFilter c;

    /**
       롼פޤ

       @param elem classǤޤinterface
    */
    protected Group(final Element elem) {
	IDManager id = IDManager.getInstance();
	c = new ChildrenFilter(elem);
	packageName = id.getIDAttribute(elem, "package");
	name = id.getIDAttribute(elem, "name");
        nameSpace
	    = ((c.getDirectChildrenByTagName("namespace").getLength() > 0)
	       ? packageName + "_" + name + "_" : null);
        desc = new Description(c.getDirectChildrenByTagName("desc"));
	gm = new GroupManager(packageName, name, nameSpace);
    }

    /**
       Υ롼פΥ롼ץޥ͡ޤ

       @return Υ롼פΥ롼ץޥ͡
    */
    protected GroupManager getGroupManager() {
        return gm;
    }

    /**
       Υ롼פλҥΡɥե륿ޤ

       @return Υ롼פλҥΡɥե륿
    */
    protected ChildrenFilter getChildrenFilter() {
        return c;
    }

    /**
       Υ롼פ̾ޤ

       @return Υ롼פ̾
    */
    public String getName() {
        return name;
    }

    /**
       Υ롼פΥѥå̾ޤ

       @return Υ롼פΥѥå̾
    */
    public String getPackageName() {
	return packageName;
    }

    /**
       Υ롼פ̾Ÿλ̵ͭޤ

       @return ̾Ÿλ꤬trueʤfalse
    */
    public boolean isNamespaceExpanded() {
	return nameSpace != null;
    }

    /**
       HTMLޤ

       @return HTML
    */
    public String getBriefDescription() {
        return desc.getBriefText();
    }

    /**
       HTMLޤ

       @return HTML
    */
    public String getDescription() {
        return desc.getText();
    }

    /**
       ꤷǥ쥯ȥΥե˽񤯥饤ޤ

       @param dirName ǥ쥯ȥ̾
       @param fileName ե̾
       @return 饤
    */
    protected PrintWriter createPrintWriter(final String dirName,
					    final String fileName) {
	return Sanctuary.createPrintWriter(dirName, fileName, "UTF-8");
    }

    /**
       Υ롼פΥפޤ

       @return 
    */
    protected abstract String getType();

    /**
       إåեޤ
    */
    public abstract void printCode();

    /**
       HTMLΥɥȤޤ
    */
    public void printHtml() {
	String fileName = packageName + "_" + name + ".html";
	PrintWriter wr = Sanctuary.createPrintWriter(null, fileName, "UTF-8");
	printHtmlHeader(wr, getType());
	printHtml(wr);
	printHtmlFooter(wr);
	wr.close();
    }

    /**
       HTMLեΥإåϤޤ

       @param wr 饤
       @param s "Class" ޤ "Interface"
    */
    private void printHtmlHeader(final PrintWriter wr, final String s) {
	String contentType = "text/html; charset=utf-8";

	wr.println(""
+ "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
+ "<html>\n"
+ "  <head>\n"
+ "    <meta HTTP-EQUIV=\"Content-Type\" CONTENT=\"" + contentType + "\">\n"
+ "    <title>" + packageName + "_" + name + "</title>\n"
+ "    <link rel=\"stylesheet\" type=\"text/css\" href=\"sanctuary.css\">\n"
+ "  </head>\n"
+ "  <body>\n"
+ "    <h3>package " + packageName + "</h3>\n"
+ "    <h1>" + s + " " + name + "</h1>\n"
+ "    <dl><dd>" + getDescription() + "</dd></dl>\n"
+ "    <hr>");
    }

    /**
       HTMLեʸϤޤ

       @param wr 饤
    */
    protected abstract void printHtml(final PrintWriter wr);

    /**
       HTMLեΥեåϤޤ

       @param wr 饤
    */
    private void printHtmlFooter(final PrintWriter wr) {
	wr.println(""
+ "  </body>\n"
+ "</html>");
    }

    /**
       TeXեޤ
    */
    public void printTex() {
	String fileName = packageName + "_" + name + ".tex";
	PrintWriter wr = Sanctuary.createPrintWriter(null, fileName, "EUC-JP");
	String ns = packageName + "." + name;

	wr.print(""
+ "\\S" + getType() + "{" + name + "}\n"
+ "\\Shypertarget{:" + Tex.safeTarget(ns) + ":}{}\n"
+ desc.getTexText() + "\n");
	printTex(wr);
	wr.close();
    }

    /**
       TeXեʸϤޤ

       @param wr 饤
    */
    protected abstract void printTex(PrintWriter wr);

    /**
       ֤Υեޤ
    */
    public abstract void printStub();
}
