/*
	$Id: ToplevelCompoundImpl.java 253 2006-08-13 14:05:36Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ȥåץ٥륳ѥɤμǤ
*/
public abstract class ToplevelCompoundImpl extends CompoundImpl
    implements ToplevelCompound {

    /** ι¤Τޤ϶Τޤ󷿤̾ */
    private String as;

    /**
       ȥåץ٥륳ѥɤޤ

       @param gm 롼ץޥ͡
       @param label "struct" ޤ "union" ޤ "enum"
       @param elem structǤޤunionǤޤenum
       @param tag tag°
       @param as alias°͡typedef̾
    */
    protected ToplevelCompoundImpl(final GroupManager gm, final String label,
				   final Element elem, final String tag,
				   final String as) {
	super(gm, label, elem, tag,
	      (!as.equals("")) ? as : label + " " + tag);
	this.as = as;
    }

    /**
       {@inheritDoc}
    */
    @Override protected final Description getDescription(
	final ChildrenFilter c) {
	return new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getFieldName(final IDManager m) {
	if (as.equals("")) {
	    return super.getFieldName(m);
	}
	return "<b>" + m.getString(as) + "</b> ("
	    + m.getString(tag.equals("") ? label : label + " " + tag)
	    + ")";
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getFieldName() {
	if (as.equals("")) {
	    return super.getFieldName();
	}
	return "<b>" + as + "</b> ("
	    + (tag.equals("") ? label : label + " " + tag)
	    + ")";
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getTexFieldName() {
	if (as.equals("")) {
	    return super.getTexFieldName();
	}
	return as + " ("
	    + (tag.equals("") ? label : label + " " + tag)
	    + ")";
    }

    public void printCode(final PrintWriter wr) {
	String indent = "    ";
	String pre = "", post = "";
	if (!as.equals("")) {
	    pre = "typedef " + label;
	    if (!tag.equals("")) {
		pre += " " + tag;
	    }
	    pre += " {";
	    post = "} " + as + ";";
	} else {
	    pre = label + " " + tag + " {";
	    post = "};";
	}
	wr.println(pre);
	components.printCode(wr, indent);
	wr.println(post);
    }
}
